#pragma semicolon 1

#include <sourcemod>
#include <sdktools>
#include <cstrike>

#define PLUGIN_VERSION "1.0"

#define HEGRENADE 11
#define FLASHBANG 12
#define SMOKEGREN 13

public Plugin:myinfo =
{
	name = "Knife & Nade Drop",
	author = "Trostal",
	description = "Drop the Knife and Greande with 'G' Key",
	version = PLUGIN_VERSION,
	url = "http://cafe.naver.com/sourcemulti"
};

public OnPluginStart()
{
	CreateConVar("sm_equipment_drop_version", PLUGIN_VERSION, "Equipment Drop Version", FCVAR_PLUGIN|FCVAR_SPONLY|FCVAR_REPLICATED|FCVAR_NOTIFY);
	
	RegConsoleCmd("drop", Command_Drop);
}

public Action:Command_Drop(client, args)
{
	if (IsClientInGame(client))
	{
		new String:sz_Classname[32];
		new weapon = GetEntPropEnt(client, Prop_Send, "m_hActiveWeapon");
		GetEdictClassname(weapon, sz_Classname, sizeof(sz_Classname));
		if (IsValidEdict(weapon))
		{
			if(StrEqual("weapon_knife", sz_Classname))
			{
				CS_DropWeapon(client, weapon, true);
				return Plugin_Handled;
			}
			else if(StrEqual("weapon_hegrenade", sz_Classname, false))
			{
				if(GetClientGrenades(client, HEGRENADE) > 0)
				{
					CS_DropWeapon(client, weapon, true);
					return Plugin_Handled;
				}
			}
			else if(StrEqual("weapon_flashbang", sz_Classname, false))
			{
				if(GetClientGrenades(client, FLASHBANG) > 0)
				{
					CS_DropWeapon(client, weapon, true);
					return Plugin_Handled;
				}
			}
			else if(StrEqual("weapon_smokegrenade", sz_Classname, false))
			{
				if(GetClientGrenades(client, SMOKEGREN) > 0)
				{
					CS_DropWeapon(client, weapon, true);
					return Plugin_Handled;
				}
			}
		}
	}
	return Plugin_Continue;
}

GetClientGrenades(client, slot)
{
	new offsNades = FindDataMapOffs(client, "m_iAmmo") + (slot * 4);
	
	return GetEntData(client, offsNades);
}