#pragma semicolon 1

#include <sourcemod>
#include <sdktools>
#include <cstrike>

#define PLUGIN_VERSION "1.3.5"

#define HEGRENADE 11
#define FLASHBANG 12
#define SMOKEGRENADE 13

public Plugin:myinfo = {
	
	name = "Drop Knife & Nade",
	author = "Trostal",
	description = "Drop the Knife and Greande with 'G' Key",
	version = PLUGIN_VERSION,
	url = "http://cafe.naver.com/sourcemulti"
};

public OnPluginStart()
{
	decl String:sGameName[16];
	GetGameFolderName(sGameName, sizeof(sGameName));
	if(!StrEqual(sGameName, "cstrike", false))
		SetFailState("Plugin only works on Counter-Strike: Source.");
	
	CreateConVar("sm_equipment_drop_version", PLUGIN_VERSION, "Equipment Drop Version", FCVAR_PLUGIN|FCVAR_SPONLY|FCVAR_REPLICATED|FCVAR_NOTIFY);
	
	RegConsoleCmd("drop", Command_Drop);
}

public Action:Command_Drop(client, args)
{
	if (IsClientInGame(client))
	{
		new String:sz_Classname[32];
		new weapon = GetEntPropEnt(client, Prop_Send, "m_hActiveWeapon");
		if (IsValidEdict(weapon))
		{
			GetEdictClassname(weapon, sz_Classname, sizeof(sz_Classname));
			
			if(StrEqual("weapon_knife", sz_Classname))
			{
				CS_DropWeapon(client, weapon, true, true);
				return Plugin_Handled;
			}
			else if(StrEqual("weapon_hegrenade", sz_Classname, false))
			{
				new nadeCount = GetClientGrenades(client, HEGRENADE);
				if(nadeCount > 0)
				{
					if(GetEntProp(weapon, Prop_Data, "m_nSequence") == 0 || GetEntProp(weapon, Prop_Data, "m_nSequence") == 1 || GetEntProp(weapon, Prop_Data, "m_nSequence") == 6)
					{
						CS_DropWeapon(client, weapon, true, true);
						
						if(nadeCount > 1)
						{
							AddNormalSoundHook(Hook_NormalSound);
							GivePlayerItem(client, sz_Classname);
							RemoveNormalSoundHook(Hook_NormalSound);
							SetClientGrenade(client, HEGRENADE, nadeCount-1);
							FakeClientCommand(client, "use %s", sz_Classname);
						}
						return Plugin_Handled;
					}
				}
			}
			else if(StrEqual("weapon_flashbang", sz_Classname, false))
			{
				new nadeCount = GetClientGrenades(client, FLASHBANG);
				if(nadeCount > 0)
				{
					if(GetEntProp(weapon, Prop_Data, "m_nSequence") == 0 || GetEntProp(weapon, Prop_Data, "m_nSequence") == 1 || GetEntProp(weapon, Prop_Data, "m_nSequence") == 6)
					{
						CS_DropWeapon(client, weapon, true, true);
						
						if(nadeCount > 1)
						{
							AddNormalSoundHook(Hook_NormalSound);
							GivePlayerItem(client, sz_Classname);
							RemoveNormalSoundHook(Hook_NormalSound);
							SetClientGrenade(client, FLASHBANG, nadeCount-1);
							FakeClientCommand(client, "use %s", sz_Classname);
						}
						return Plugin_Handled;
					}
				}
			}
			else if(StrEqual("weapon_smokegrenade", sz_Classname, false))
			{
				new nadeCount = GetClientGrenades(client, SMOKEGRENADE);
				if(nadeCount > 0)
				{
					if(GetEntProp(weapon, Prop_Data, "m_nSequence") == 0 || GetEntProp(weapon, Prop_Data, "m_nSequence") == 1 || GetEntProp(weapon, Prop_Data, "m_nSequence") == 6)
					{
						CS_DropWeapon(client, weapon, true, true);
						
						if(nadeCount > 1)
						{
							AddNormalSoundHook(Hook_NormalSound);
							GivePlayerItem(client, sz_Classname);
							RemoveNormalSoundHook(Hook_NormalSound);
							SetClientGrenade(client, SMOKEGRENADE, nadeCount-1);
							FakeClientCommand(client, "use %s", sz_Classname);
						}
						return Plugin_Handled;
					}
				}
			}
		}
	}
	return Plugin_Continue;
}


public Action:Hook_NormalSound(clients[64], &numClients, String:sample[PLATFORM_MAX_PATH], &entity, &channel, &Float:volume, &level, &pitch, &flags)
{
	if(!StrEqual(sample, "items/itempickup.wav", false))	return Plugin_Continue;	
	return Plugin_Stop;
}

GetClientGrenades(client, slot)
{
	new offsNades = FindDataMapOffs(client, "m_iAmmo") + (slot * 4);
	
	return GetEntData(client, offsNades);
}

SetClientGrenade(client, slot, amount)
{
	new offsNades = FindDataMapOffs(client, "m_iAmmo") + (slot * 4);
	
	SetEntData(client, offsNades, amount);
}