#pragma semicolon 1

#include <sourcemod>
#include <sdktools>
#include <cstrike>

#define PLUGIN_VERSION "1.5"

new iGame = -1;

new Handle:ED_Allows_Knife = 		INVALID_HANDLE;
new Handle:ED_Allows_Hegrenade = 	INVALID_HANDLE;
new Handle:ED_Allows_Flashbang = 	INVALID_HANDLE;
new Handle:ED_Allows_Smokegrenade = INVALID_HANDLE;
new Handle:ED_Allows_Zeus = 		INVALID_HANDLE;
new Handle:ED_Allows_Incgrenade = 	INVALID_HANDLE;
new Handle:ED_Allows_Molotov = 		INVALID_HANDLE;
new Handle:ED_Allows_Decoy = 		INVALID_HANDLE;


public Plugin:myinfo = {
	
	name = "Equipment Drop",
	author = "Trostal",
	description = "Allows Clients to Drop Their Knifes and Greandes with 'G' Key (When default setting).",
	version = PLUGIN_VERSION,
	url = "http://cafe.naver.com/sourcemulti"
};

public OnPluginStart()
{
	decl String:sGameName[16];
	GetGameFolderName(sGameName, sizeof(sGameName));
	if(StrEqual(sGameName, "cstrike", false))
		iGame = 1;
	else if(StrEqual(sGameName, "csgo", false))
		iGame = 2;
	else
	{
		SetFailState("This Plugin only works on Counter-Strike: Source or Counter-Strike: Global Offensive.");
		iGame = -1;
	}
	
	CreateConVar("sm_equipment_drop_version", 		PLUGIN_VERSION, "Equipment Drop Version", FCVAR_PLUGIN|FCVAR_SPONLY|FCVAR_REPLICATED|FCVAR_NOTIFY);

	ED_Allows_Knife =			CreateConVar("sm_equipment_drop_allows_knife", 			"1", 	"Plugin allows players to drop their Knives");
	ED_Allows_Hegrenade =		CreateConVar("sm_equipment_drop_allows_hegrenade", 		"1", 	"Plugin allows players to drop their HE Grenades");
	ED_Allows_Flashbang =		CreateConVar("sm_equipment_drop_allows_flashbang", 		"1", 	"Plugin allows players to drop their Flashbangs");
	ED_Allows_Smokegrenade =	CreateConVar("sm_equipment_drop_allows_smokegrenade", 	"1", 	"Plugin allows players to drop their Smoke Grenades");
	ED_Allows_Zeus =			CreateConVar("sm_equipment_drop_allows_zeus", 			"1", 	"Plugin allows players to drop their Zeus x27s (CS:GO Only)");
	ED_Allows_Incgrenade =		CreateConVar("sm_equipment_drop_allows_incgrenade", 	"1", 	"Plugin allows players to drop their Incendiary Grenades (CS:GO Only)");
	ED_Allows_Molotov =			CreateConVar("sm_equipment_drop_allows_molotov", 		"1", 	"Plugin allows players to drop their Molotov Cocktails (CS:GO Only)");
	ED_Allows_Decoy =			CreateConVar("sm_equipment_drop_allows_decoygrenade", 	"1", 	"Plugin allows players to drop their Decoy Grenades (CS:GO Only)");
	
	AutoExecConfig(true, "EquipmentDrop");
	
	AddCommandListener(Command_Drop, "drop");
}

public Action:Command_Drop(client, const String:command[], argc)
{
	if(IsClientInGame(client))
	{
		new String:sz_Classname[32];
		new weapon = GetEntPropEnt(client, Prop_Send, "m_hActiveWeapon");
		if(!IsValidEdict(weapon))	return Plugin_Stop;
		
		GetEdictClassname(weapon, sz_Classname, sizeof(sz_Classname));
		
		new nadeSlot = -1;
		if(StrEqual("weapon_knife", sz_Classname) && GetConVarInt(ED_Allows_Knife) == 1)
		{
			CS_DropWeapon(client, weapon, true, true);
			return Plugin_Handled;
		}
		if(StrEqual("weapon_knifegg", sz_Classname) && GetConVarInt(ED_Allows_Knife) == 1 && iGame == 2) // CS:GO Only (Golden Knife)
		{
			CS_DropWeapon(client, weapon, true, true);
			return Plugin_Handled;
		}
		if(StrEqual("weapon_taser", sz_Classname) && GetConVarInt(ED_Allows_Zeus) == 1 && iGame == 2) // CS:GO Only (Zeus x27)
		{
			CS_DropWeapon(client, weapon, true, true);
			return Plugin_Handled;
		}
		else if(StrEqual("weapon_hegrenade", sz_Classname, false) && GetConVarInt(ED_Allows_Hegrenade) == 1)
			nadeSlot = 11; // HE Grenade
		else if(StrEqual("weapon_flashbang", sz_Classname, false) && GetConVarInt(ED_Allows_Flashbang) == 1)
			nadeSlot = 12; // Flashbang
		else if(StrEqual("weapon_smokegrenade", sz_Classname, false) && GetConVarInt(ED_Allows_Smokegrenade) == 1)
			nadeSlot = 13; // Smoke Grenade
		else if(StrEqual("weapon_incgrenade", sz_Classname, false) && GetConVarInt(ED_Allows_Incgrenade) == 1 && iGame == 2) // CS:GO Only
			nadeSlot = 14; // Incendiary Grenade & Molotov Cocktail
		else if(StrEqual("weapon_molotov", sz_Classname, false) && GetConVarInt(ED_Allows_Molotov) == 1 && iGame == 2) // CS:GO Only
			nadeSlot = 14; // Incendiary Grenade & Molotov Cocktail
		else if(StrEqual("weapon_decoy", sz_Classname, false) && GetConVarInt(ED_Allows_Decoy) == 1 && iGame == 2) // CS:GO Only
			nadeSlot = 15; // Decoy Grenade
			
		
		if(nadeSlot == -1)	return Plugin_Continue;
		
		new nadeCount = GetClientGrenades(client, nadeSlot);
		new nSequence = GetEntProp(weapon, Prop_Data, "m_nSequence");
		if(nadeCount > 0)
		{
			if(nSequence == 0 || nSequence == 1 || (nSequence == 6 && iGame == 1) || (nSequence == 3 && iGame == 2)) // Block nade duplicating by dropping a nade when player is uping his arm (right before throwing).
			{
				CS_DropWeapon(client, weapon, true, true);
				
				if(nadeCount > 1) // Block nades vanishing when client has more than 2 nades (nade is dropped only 1, but the others are vanished).
				{
					AddNormalSoundHook(Hook_PickupSound);
					GivePlayerItem(client, sz_Classname);
					RemoveNormalSoundHook(Hook_PickupSound);
					SetClientGrenade(client, nadeSlot, nadeCount-1);
					FakeClientCommand(client, "use %s", sz_Classname);
				}
					
				return Plugin_Handled;
			}
		}
	}
	return Plugin_Continue;
}


public Action:Hook_PickupSound(clients[64], &numClients, String:sample[PLATFORM_MAX_PATH], &entity, &channel, &Float:volume, &level, &pitch, &flags)
	return StrEqual(sample, "items/itempickup.wav", false) ? Plugin_Stop : Plugin_Continue;

GetClientGrenades(client, slot)
{
	new NadeOffs = FindDataMapOffs(client, "m_iAmmo") + (slot * 4);
	
	return GetEntData(client, NadeOffs);
}

SetClientGrenade(client, slot, amount)
{
	new nadeOffs = FindDataMapOffs(client, "m_iAmmo") + (slot * 4);
	
	SetEntData(client, nadeOffs, amount);
}